#include "BluetoothSerial.h"
#include <Preferences.h>

#if !defined(CONFIG_BT_ENABLED) || !defined(CONFIG_BLUEDROID_ENABLED)
#error Bluetooth is not enabled! Please run `make menuconfig` to and enable it
#endif

BluetoothSerial SerialBT;
Preferences wifi_set_p;

char wifi_nam[15];
char wifi_passwd[35];
String wifi_nam1;
String  wifi_passwd1;
String buffer_string;
//wifi_set_def wifi_set;

//Чтение данных из ЭНП
bool init_read()
{
  wifi_set_p.begin("robot_ini", false); //
  if (wifi_set_p.getBytes("wifi_nam", wifi_nam, sizeof(wifi_nam)) == 0 ) {wifi_set_p.end(); return false;}
  if (wifi_set_p.getBytes("wifi_passwd", wifi_passwd, sizeof(wifi_passwd)) == 0 ) { wifi_set_p.end(); return false;}
  wifi_set_p.end();
  return true;
}
//Запись данных в ЭНП
bool init_write()
{
  wifi_set_p.begin("robot_ini", false); //
  if (wifi_set_p.putBytes("wifi_nam", wifi_nam, sizeof(wifi_nam)) == 0 ) { wifi_set_p.end(); return false;}
  if (wifi_set_p.putBytes("wifi_passwd", wifi_passwd, sizeof(wifi_passwd)) == 0 ) { wifi_set_p.end(); return false;}
  wifi_set_p.end();
  return true;
}
//Включение BT и Чтение данных из ЭНП
bool btEN_iniSET()
{
 bool result=true;
 // SerialBT.begin("CamDrvBt"); //Bluetooth device name
  if (!init_read())
  {
    memset(wifi_nam, 0, sizeof(wifi_nam));
    memset(wifi_passwd, 0, sizeof(wifi_passwd));
    result= false;
  }
       Serial.print("wifi_nam=");Serial.println(wifi_nam);
       Serial.print("wifi_passwd=");Serial.println(wifi_passwd);
       return result;
}

String W_ = "w=";
String P_ = "p=";
bool bt_read_wifi_set()
{
  //1 -- начало ввод имени(получен знак w), ждем знак равно,
  //2- получен знак равно, начат ввод имени
  //3 - ввод имени завершен
  //4 -начало ввод пароля(получен знак p), ждем знак равно,
  //5- получен знак равно, начат ввод пароля
  //6- ввод пароля завершен
  static uint8_t status_string = 0;
  static uint8_t count_string = 0;
  static String temp_string;
  while (SerialBT.available())
  {
    uint8_t x = SerialBT.read();
      temp_string += char(x);
      count_string++;
      if (((status_string == 0) || (status_string == 2)) && (count_string == 2))
      {
        if (temp_string == W_)
        {
          status_string = 1;
          count_string = 0;
          temp_string = "";
          delay(1);
          continue;
        }
        if (temp_string == P_)
        {
          status_string = 3;
          count_string = 0;
          temp_string = "";
          delay(1);
          continue;
        }
        //теряем
        temp_string = char(x);
        count_string--;
        continue;
      }
      else
      {
        if (status_string == 1) //Ввод имени
        {
          if (x != 10) {
            count_string++;
            wifi_nam1 += char(x);
            continue;
          } else {
            temp_string = "";
            count_string=0;
            status_string = 2;
            continue;
          }
        }
        if (status_string == 3) //Ввод пароля
        {
          if (x != 10) {
            count_string++;
            wifi_passwd1 += char(x);
            continue;
          } else {
            temp_string = "";
            count_string=0;
            status_string = 4;
          }
        }
      }
      if (status_string == 4)
      {
        wifi_nam1.trim();
        wifi_passwd1.trim();
        wifi_nam1.toCharArray(wifi_nam, 15);
        wifi_passwd1.toCharArray(wifi_passwd, 35);
        temp_string = "";
        wifi_nam1 = "";
        wifi_passwd1 = "";
        count_string=0;
        status_string = 0;
        init_write();
        Serial.print("to_write_wifi_nam=");Serial.println(wifi_nam);
        Serial.print("to_write_wifi_passwd=");Serial.println(wifi_passwd);
        return true;
      }
      //stringTwo.replace("w=", "");
      //stringTwo.replace("p=", "");
      //string.substring(0, 2);
      //string.indexOf(val)
    }
    //Serial.println(wifi_nam);
    //if (charer == 10) //Если пришел конец строки
    //wifi_nam = .... enter
    //wifi_passwd = .... enter
    return false;
}
